; Rcepteur 3 voies - Tlcommande HF
; Doumai.Terret@Wanadoo.fr
; Merci de laisser mon adresse si vous modifiez le programme
; Rsonnateur = 4Mhz
;
	LIST      P=16F628, F=INHX8M, r=dec
	include "P16F628.inc"
;            
	__CONFIG	_BODEN_OFF  & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _XT_OSC
;	
	; Do not show warnings										
	ERRORLEVEL      -224
;
; Dclaration des variables
;
	cblock	0x20
TRAME0,TRAME1,TRAME2			; 4 bits de la trame reue, en cours, 1re mmo, 2me mmo
I,J,K							; pour le comptage
ST3								; pour le comptage entre deux trames
	endc
;
; Define
;
	#define CAV1 PORTB,0		; Cavalier Mode impulsionnel / bistable
	#define REL1 PORTB,5		; Relais K3
	#define REL2 PORTB,6		; Relais K2
	#define REL3 PORTB,7		; Relais K1
	#define LED1 PORTA,1		; Tmoin de rception
	#define REC	PORTA,2			; Entre numrique en provenance du rcepteur

;
	org     0
	goto    Start
;
	org     10

Start	bcf		STATUS,RP0		; Bank 0
		movlw	0x07			; Dsactivation du mode comparateur et
		movwf	CMCON			; passe en mode Entres / Sorties
;
		bsf     STATUS,RP0		; Bank 1
		movlw	B'00000001'		; 
		movwf	TRISB			; RB0 Cavalier, RB5  RB7 relais
		movlw	B'00000100'		; 
	 	movwf   TRISA			; RA1 LED, RA2 rception HF
		bcf		STATUS,RP0		; Bank 0
;
		clrf	PORTB			; Tous les relais non aliments
		clrf	PORTA			; LED teinte
;
Debut	bcf		LED1			; teint la LED de rception
;
; Lecture du cavalier
; Si on est en mode impulsionnel, on coupe l'alim des relais
;
		btfss	CAV1				; Test l'tat du cavalier
		clrf	PORTB				; Coupe l'alim relais
;
; Dtection d'un tat 0 de 1,5 ms sur REC pour la lecture de la premire trame
; On test 255 fois si le signal reu est  0
; Si c'est le cas, on se situe entre deux trames
;
		movlw	0xFF
		movwf	ST3					; ST3=255
InterT0	btfss	REC					; Test de l'tat logique du signal HF reu
		goto	InterT1				; Le signal est  0
		goto	Debut				; Le signal est  1, on attend une inter trame
InterT1	decfsz	ST3,F				; Dcrmente ST3
		goto	InterT0				; On continu  tester REC
;
; On est dans une inter-trame
; Lecture et sauvegarde des 4 bits ( les 3 poussoirs + 1 bit  0 )
;
		call	Trame				; Lecture des 4 bits
		movf	TRAME0,W
		movwf	TRAME1				; Sauvegarde des 4 bits qui viennent d'tre lus dans TRAME1
;
; Dtection d'un tat 0 de 1,5 ms sur REC pour la lecture de la deuxime trame
;

Det1	movlw	0xFF
		movwf	ST3
InterT2	btfss	REC
		goto	InterT3
		goto	Debut
InterT3	decfsz	ST3,F
		goto	InterT2
;
; On est dans une inter-trame
; Lecture et sauvegarde des 4 bits
;
		call	Trame				; Lecture des 4 bits
		movf	TRAME0,W
		movwf	TRAME2				; Sauvegarde des 4 bits qui viennent d'tre lus dans TRAME2
;
; Comparaison des deux trames recues par HF. Les 2 trames doivent tre identiques
;
		movf	TRAME1,W			; W=TRAME1
		subwf	TRAME2,W			; W=TRAME2-TRAME1
		btfsc	STATUS,Z			; Test si le rsultat est nul
		goto	Comp0				; Les deux trames sont identiques
		goto	Debut				; Les deux trames sont diffrentes
Comp0
;
; Dtection d'un tat 0 de 1,5 ms sur REC pour la lecture de la troisime trame
;

Det2	movlw	0xFF
		movwf	ST3
InterT4	btfss	REC
		goto	InterT5
		goto	Debut
InterT5	decfsz	ST3,F
		goto	InterT4
;
; On est dans une inter-trame
; Lecture et sauvegarde des 4 bits
;
		call	Trame				; Lecture des 4 bits
		movf	TRAME0,W
		movwf	TRAME2				; Sauvegarde des 4 bits qui viennent d'tre lus dans TRAME2
;
; Comparaison des deux trames recues par HF. Les 2 trames doivent tre identiques
;
		movf	TRAME1,W			; W=TRAME1
		subwf	TRAME2,W			; W=TRAME2-TRAME1
		btfsc	STATUS,Z			; Test si le rsultat est nul
		goto	Comp1				; Les deux trames sont identiques
		goto	Debut				; Les deux trames sont diffrentes
Comp1
;
; Mode impulsionnel : Cavalier en place
; Les deux trames sont identiques
; Mise  l'tat 1 de l'une des 3 sorties
;
		btfsc	CAV1				; Test l'tat du cavalier
		goto	Bist				; On saute au mode bistable
; On est en mode impulsionnel
		bsf		LED1				; Allume la LED de rception
		movf	TRAME2,W			; W=TRAME2
;
		movlw	0x40				; Relais K1  la rception
		subwf	TRAME2,W			; K1 ?
		btfsc	STATUS,Z			; Si pas K1, on va traiter K2
		bsf		REL1				; K1 aliment
;
		movlw	0x20				; Relais K2  la rception
		subwf	TRAME2,W					
		btfsc	STATUS,Z
		bsf		REL2
;
		movlw	0x10
		subwf	TRAME2,W			; Relais K3  la rception
		btfsc	STATUS,Z
		bsf		REL3
;
		goto 	Att					; Attente 2 secondes vite les rebonds
;
; Mode bistable : pas de cavalier
; Les deux trames sont identiques
; Changement de l'tat de l'une des 3 sorties
;
Bist	bsf		LED1				; Allume la LED de rception
		movf	TRAME2,W			; W=TRAME2
;
Rel1	movlw	0x40				; Relais K1  la rception
		subwf	TRAME2,W			; K1 ?
		btfss	STATUS,Z			; Skip si K1
		goto	Rel2				; Ce n'est pas K1, on va traiter K2
		movlw	0x20				; Masque pour K1
		xorwf	PORTB,F				; Change l'tat du relais K1
;
Rel2	movlw	0x20				; Relais K2  la rception
		subwf	TRAME2,W					
		btfss	STATUS,Z
		goto	Rel3
		movlw	0x40
		xorwf	PORTB,F				; Change l'tat du relais K2
;
Rel3	movlw	0x10				; Relais K3  la rception
		subwf	TRAME2,W			
		btfss	STATUS,Z
		goto	Att					; A
		movlw	0x80
		xorwf	PORTB,F				; Change l'tat du relais K3
;
; On attend 2 secondes en mode bistable pour que le poussoir soit relch
; On attend 2 secondes en mode impulsionnel pour viter les rebonds du BP
; Trois boucles imbriques
;
Att		movlw	10
		movwf	K
T0		movlw	255
		movwf	J
T1		movlw	255
		movwf	I							
T2		decfsz	I,F
		goto	T2
		decfsz	J,F
		goto	T1
		decfsz	K,F
		goto	T0
;
		goto 	Det1				; On part relire une trame
;
; On sort d'une inter-trame
; Extraction des 4 bits d'une trame
;
Trame	clrf	TRAME0				; TRAME0=0 La trame courante est stocke dans TRAME0
		movlw	4					; Pour lecture des 4 bits
		movwf	K					; K=4
Ext1	btfsc	REC					; On est encore dans l'inter trame
		goto	Ext2				; Front montant
		goto	Ext1				; On attend le premier front montant
Ext2	btfss	REC					; on est sur un tat haut, on attend le front descendant
		goto	Ext3				; Front descendant
		goto	Ext2				; On attend le front descendant
;
Ext3	movlw	120					; Attente d' 1,5 bit (environ 375 s)
		movwf	I					; pour se retrouver au milieu du bit  lire
Temp15	decfsz	I,F
		goto	Temp15
;
		movf	PORTA,W				; W=PORTA
		movwf	I					; I=PORTA
		rrf		I,F					; Trois rotations pour retrouver RA2 (bit  lire) sur Carry
		rrf		I,F					;
		rrf		I,F					; REC dans le bit de Carry
		rrf		TRAME0,F			; sauvegarde du bit qui vient d'tre lu dans TRAME0,7
;
		movlw	70					; Attente d'une dure approximative d'un bit
		movwf	I					; pour se retrouver juste avant le prochain front descendant.
Temp10	decfsz	I,F					; 212 s
		goto	Temp10
;	
		decfsz	K,F					; On dcrmente K
		goto	Ext2				; On passe  la lecture du bit suivant
;									; La lecture des 4 bits est termine
;		swapf	TRAME0,F			; Le code sur les 4 bits sur le quartet de poids faible
;
		movlw	160					; Les 4 bits ont t lus, on passe le bit Stop et
		movwf	I					; on saute dans l'inter-trame
Temp16	decfsz	I,F					; 482 s
		goto	Temp16
;
	Return
;
; Tempo de 127 s
;
Temp300
	movlw	41
	movwf	I							
Temp300a
	decfsz	I,F					; 127 s ()
	goto	Temp300a
	Return
;	
	end

	



