;============================================================================================
; metteur 3 voies pour tlcommande
; Doumai.Terret@Wanadoo.fr
; Merci de laisser mon Mail pour toute modification du logiciel
;============================================================================================
;
	LIST      P=16F628, F=INHX8M, r=dec
	include "P16F628.inc"
;            
	__CONFIG	_BODEN_OFF  & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _XT_OSC
;	
	; Do not show warnings										
	ERRORLEVEL      -224
			
#DEFINE EM1		PORTA,1		; Attaque l'metteur
#DEFINE LED		PORTA,2		; LED d'indication de l'mission
;
	cblock 0x20
MOT : 1						; Sauvegarde de l'tat de BP
MOT1 : 1					; Mot de 4 bit  mettre
I : 1						; Comptage Tempo
J : 1						; Comptage gnral

		endc
;
;============================================================================================
	ORG	0x0000	
		goto	main
;
main:	bcf		STATUS,RP0		; Bank 0
		movlw	0x07			; Dsactivation du mode comparateur et
		movwf	CMCON			; passe en mode Entres / Sorties
;
		bsf     STATUS,RP0		; Bank 1
		movlw	B'11110000'		; 
		movwf	TRISB			; RB4  RB7 en entre
	 	clrf    TRISA			; PortA en sortie
		bcf		STATUS,RP0		; Bank 0
;
		clrf	PORTB
		clrf	PORTA
;============================================================================================
; Lecture des boutons poussoirs
;============================================================================================
Lect	movf	PORTB,W			; Lecture des BP
		movwf	MOT				; tat des BP dans MOT
;
		bsf		LED				; Allumage de la LED pendant l'mission
;============================================================================================
; mission
; Une trame comprend 4 bits suivi d'un Stop  l'tat 1 durant 250 s
; Un bit est constitu d'un Start  l'tat 1 suivi d'un 0 suivi par l'tat du bit
;============================================================================================
Trame	movf	MOT,W
		movwf	MOT1						; tat des interrupteurs dans MOT1
		movlw	0x04
		movwf	J							; J=4 pour les 4 bits  transmettre

DebBit	bsf		EM1							; Start du 1er bit,
		call	Temp250						; d'une dure de 250 s
		bcf		EM1							; Front descendant
		call	Temp250						; tat 0 durant 250 s
		rlf		MOT1,F						; Bit  mettre danc Carry
		btfss	STATUS,C					; Test si le bit courant est  1
		goto	Ec0							; On va crire un 0 sur l'entre de l'metteur
		bsf		EM1							; Bit  mettre  1
		call	Temp250						; tat 1 durant 250 s
		goto	FinBit						; Fin d'mission d'une trame
Ec0		nop
		bcf		EM1							; Bit  mettre  0
		call	Temp250						; tat 0 durant 250 s
FinBit	decfsz	J,F							; J = J - 1
		goto	DebBit						; Si J<>0 on retourne mettre un bit
;
		bsf		EM1							; Bit Stop  1
		call	Temp250						; tat 1 durant 250 s
		bcf		EM1							; Signal  l'tat 0
;============================================================================================
; Inter Trame
;============================================================================================
		movlw	8							; 8 fois 250 s = 2ms d'inter-trame
		movwf	J							; 2ms  l'tat 0 entre deux trames
InterT	call 	Temp250
		decfsz	J,F
		goto	InterT
;
		goto	Lect						; On retourne lire l'tat des BP
;
;============================================================================================
; Tempo de 250 s
;============================================================================================
Temp250
	movlw	80
	movwf	I
Temp250a
	decfsz	I,F
	goto	Temp250a
	Return
;
	end

	



